summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorgithub-actions[bot] <41898282+github-actions[bot]@users.noreply.github.com>2021-12-10 00:01:53 +0000
committerGitHub <noreply@github.com>2021-12-10 00:01:53 +0000
commit92aabc6576eead6b544354f10ccb865e180173f4 (patch)
tree4a0df408a18c940a8e2f078bc472e40716fd5d94
parent28ce39388c80ecb81ca84eab723923872f20792c (diff)
parent9fb7d91888fa24a7f96fd1915da2d4bc5e9b834e (diff)
Merge master into staging-next
-rw-r--r--doc/languages-frameworks/python.section.md22
-rw-r--r--doc/stdenv/stdenv.chapter.md12
-rw-r--r--lib/systems/doubles.nix4
-rw-r--r--lib/systems/examples.nix1
-rw-r--r--maintainers/maintainer-list.nix6
-rw-r--r--nixos/modules/hardware/keyboard/zsa.nix3
-rw-r--r--pkgs/applications/science/math/polymake/default.nix4
-rw-r--r--pkgs/applications/version-management/gitlab/gitaly/default.nix2
-rw-r--r--pkgs/build-support/setup-hooks/make-binary-wrapper.sh384
-rw-r--r--pkgs/data/misc/hackage/pin.json8
-rw-r--r--pkgs/development/haskell-modules/configuration-common.nix3
-rw-r--r--pkgs/development/haskell-modules/configuration-hackage2nix/broken.yaml1
-rw-r--r--pkgs/development/haskell-modules/hackage-packages.nix173
-rw-r--r--pkgs/development/libraries/ntl/default.nix4
-rw-r--r--pkgs/development/python-modules/freezegun/default.nix10
-rw-r--r--pkgs/development/python-modules/python-lsp-black/default.nix4
-rw-r--r--pkgs/development/ruby-modules/gem-config/default.nix9
-rw-r--r--pkgs/os-specific/linux/zsa-udev-rules/default.nix11
-rw-r--r--pkgs/servers/dns/knot-resolver/default.nix10
-rw-r--r--pkgs/test/default.nix2
-rw-r--r--pkgs/test/make-binary-wrapper/add-flags.c21
-rw-r--r--pkgs/test/make-binary-wrapper/add-flags.cmdline2
-rw-r--r--pkgs/test/make-binary-wrapper/add-flags.env6
-rw-r--r--pkgs/test/make-binary-wrapper/argv0.c7
-rw-r--r--pkgs/test/make-binary-wrapper/argv0.cmdline1
-rw-r--r--pkgs/test/make-binary-wrapper/argv0.env2
-rw-r--r--pkgs/test/make-binary-wrapper/basic.c7
-rw-r--r--pkgs/test/make-binary-wrapper/basic.cmdline0
-rw-r--r--pkgs/test/make-binary-wrapper/basic.env2
-rw-r--r--pkgs/test/make-binary-wrapper/chdir.c11
-rw-r--r--pkgs/test/make-binary-wrapper/chdir.cmdline1
-rw-r--r--pkgs/test/make-binary-wrapper/chdir.env2
-rw-r--r--pkgs/test/make-binary-wrapper/combination.c53
-rw-r--r--pkgs/test/make-binary-wrapper/combination.cmdline6
-rw-r--r--pkgs/test/make-binary-wrapper/combination.env8
-rw-r--r--pkgs/test/make-binary-wrapper/default.nix54
-rw-r--r--pkgs/test/make-binary-wrapper/env.c14
-rw-r--r--pkgs/test/make-binary-wrapper/env.cmdline4
-rw-r--r--pkgs/test/make-binary-wrapper/env.env6
-rw-r--r--pkgs/test/make-binary-wrapper/envcheck.c22
-rw-r--r--pkgs/test/make-binary-wrapper/inherit-argv0.c6
-rw-r--r--pkgs/test/make-binary-wrapper/inherit-argv0.cmdline1
-rw-r--r--pkgs/test/make-binary-wrapper/inherit-argv0.env2
-rw-r--r--pkgs/test/make-binary-wrapper/invalid-env.c14
-rw-r--r--pkgs/test/make-binary-wrapper/invalid-env.cmdline2
-rw-r--r--pkgs/test/make-binary-wrapper/prefix.c26
-rw-r--r--pkgs/test/make-binary-wrapper/prefix.cmdline2
-rw-r--r--pkgs/test/make-binary-wrapper/prefix.env3
-rw-r--r--pkgs/test/make-binary-wrapper/suffix.c26
-rw-r--r--pkgs/test/make-binary-wrapper/suffix.cmdline2
-rw-r--r--pkgs/test/make-binary-wrapper/suffix.env3
-rw-r--r--pkgs/tools/graphics/blockhash/default.nix8
-rw-r--r--pkgs/top-level/all-packages.nix15
53 files changed, 930 insertions, 82 deletions
diff --git a/doc/languages-frameworks/python.section.md b/doc/languages-frameworks/python.section.md
index 9fd475261c0b..84721daa28f1 100644
--- a/doc/languages-frameworks/python.section.md
+++ b/doc/languages-frameworks/python.section.md
@@ -1633,3 +1633,25 @@ would be:
```ShellSession
$ maintainers/scripts/update-python-libraries --target minor --commit --use-pkgs-prefix pkgs/development/python-modules/**/default.nix
```
+
+## CPython Update Schedule
+
+With [PEP 602](https://www.python.org/dev/peps/pep-0602/), CPython now
+follows a yearly release cadence. In nixpkgs, all supported interpreters
+are made available, but only the most recent two
+interpreters package sets are built; this is a compromise between being
+the latest interpreter, and what the majority of the Python packages support.
+
+New CPython interpreters are released in October. Generally, it takes some
+time for the majority of active Python projects to support the latest stable
+interpreter. To help ease the migration for Nixpkgs users
+between Python interpreters the schedule below will be used:
+
+| When | Event |
+| --- | --- |
+| After YY.11 Release | Bump CPython package set window. The latest and previous latest stable should now be built. |
+| After YY.05 Release | Bump default CPython interpreter to latest stable. |
+
+In practice, this means that the Python community will have had a stable interpreter
+for ~2 months before attempting to update the package set. And this will
+allow for ~7 months for Python applications to support the latest interpreter.
diff --git a/doc/stdenv/stdenv.chapter.md b/doc/stdenv/stdenv.chapter.md
index c108fffd1b01..6d72bd0deb4f 100644
--- a/doc/stdenv/stdenv.chapter.md
+++ b/doc/stdenv/stdenv.chapter.md
@@ -796,7 +796,7 @@ The standard environment provides a number of useful functions.
### `makeWrapper` \<executable\> \<wrapperfile\> \<args\> {#fun-makeWrapper}
-Constructs a wrapper for a program with various possible arguments. For example:
+Constructs a wrapper for a program with various possible arguments. It is defined as part of 2 setup-hooks named `makeWrapper` and `makeBinaryWrapper` that implement the same bash functions. Hence, to use it you have to add `makeWrapper` to your `nativeBuildInputs`. Here's an example usage:
```bash
# adds `FOOBAR=baz` to `$out/bin/foo`’s environment
@@ -808,9 +808,11 @@ makeWrapper $out/bin/foo $wrapperfile --set FOOBAR baz
makeWrapper $out/bin/foo $wrapperfile --prefix PATH : ${lib.makeBinPath [ hello git ]}
```
-There’s many more kinds of arguments, they are documented in `nixpkgs/pkgs/build-support/setup-hooks/make-wrapper.sh`.
+There’s many more kinds of arguments, they are documented in `nixpkgs/pkgs/build-support/setup-hooks/make-wrapper.sh` for the `makeWrapper` implementation and in `nixpkgs/pkgs/build-support/setup-hooks/make-binary-wrapper.sh` for the `makeBinaryWrapper` implementation.
-`wrapProgram` is a convenience function you probably want to use most of the time.
+`wrapProgram` is a convenience function you probably want to use most of the time, implemented by both `makeWrapper` and `makeBinaryWrapper`.
+
+Using the `makeBinaryWrapper` implementation is usually preferred, as it creates a tiny _compiled_ wrapper executable, that can be used as a shebang interpreter. This is needed mostly on Darwin, where shebangs cannot point to scripts, [due to a limitation with the `execve`-syscall](https://stackoverflow.com/questions/67100831/macos-shebang-with-absolute-path-not-working). Compiled wrappers generated by `makeBinaryWrapper` can be inspected with `less <path-to-wrapper>` - by scrolling past the binary data you should be able to see the shell command that generated the executable and there see the environment variables that were injected into the wrapper.
### `substitute` \<infile\> \<outfile\> \<subs\> {#fun-substitute}
@@ -885,9 +887,9 @@ someVar=$(stripHash $name)
### `wrapProgram` \<executable\> \<makeWrapperArgs\> {#fun-wrapProgram}
-Convenience function for `makeWrapper` that automatically creates a sane wrapper file. It takes all the same arguments as `makeWrapper`, except for `--argv0`.
+Convenience function for `makeWrapper` that replaces `<\executable\>` with a wrapper that executes the original program. It takes all the same arguments as `makeWrapper`, except for `--inherit-argv0` (used by the `makeBinaryWrapper` implementation) and `--argv0` (used by both `makeWrapper` and `makeBinaryWrapper` wrapper implementations).
-It cannot be applied multiple times, since it will overwrite the wrapper file.
+If you will apply it multiple times, it will overwrite the wrapper file and you will end up with double wrapping, which should be avoided.
## Package setup hooks {#ssec-setup-hooks}
diff --git a/lib/systems/doubles.nix b/lib/systems/doubles.nix
index 8af3377fb5bf..00e57339a310 100644
--- a/lib/systems/doubles.nix
+++ b/lib/systems/doubles.nix
@@ -39,8 +39,8 @@ let
"riscv32-netbsd" "riscv64-netbsd" "x86_64-netbsd"
# none
- "aarch64-none" "arm-none" "armv6l-none" "avr-none" "i686-none"
- "msp430-none" "or1k-none" "m68k-none" "powerpc-none"
+ "aarch64_be-none" "aarch64-none" "arm-none" "armv6l-none" "avr-none" "i686-none"
+ "msp430-none" "or1k-none" "m68k-none" "powerpc-none" "powerpcle-none"
"riscv32-none" "riscv64-none" "s390-none" "s390x-none" "vc4-none"
"x86_64-none"
diff --git a/lib/systems/examples.nix b/lib/systems/examples.nix
index f2469f9bf7ff..9c0c91617e8a 100644
--- a/lib/systems/examples.nix
+++ b/lib/systems/examples.nix
@@ -290,6 +290,7 @@ rec {
libc = "nblibc";
};
+ # this is broken and never worked fully
x86_64-netbsd-llvm = {
config = "x86_64-unknown-netbsd";
libc = "nblibc";
diff --git a/maintainers/maintainer-list.nix b/maintainers/maintainer-list.nix
index a90651883e7d..c547274ee9de 100644
--- a/maintainers/maintainer-list.nix
+++ b/maintainers/maintainer-list.nix
@@ -1414,6 +1414,12 @@
githubId = 251106;
name = "Daniel Bergey";
};
+ bergkvist = {
+ email = "tobias@bergkv.ist";
+ github = "bergkvist";
+ githubId = 410028;
+ name = "Tobias Bergkvist";
+ };
betaboon = {
email = "betaboon@0x80.ninja";
github = "betaboon";
diff --git a/nixos/modules/hardware/keyboard/zsa.nix b/nixos/modules/hardware/keyboard/zsa.nix
index 5cb09e5af499..bb69cfa0bf09 100644
--- a/nixos/modules/hardware/keyboard/zsa.nix
+++ b/nixos/modules/hardware/keyboard/zsa.nix
@@ -5,7 +5,6 @@ let
cfg = config.hardware.keyboard.zsa;
in
{
- # TODO: make group configurable like in https://github.com/NixOS/nixpkgs/blob/0b2b4b8c4e729535a61db56468809c5c2d3d175c/pkgs/tools/security/nitrokey-app/udev-rules.nix ?
options.hardware.keyboard.zsa = {
enable = mkOption {
type = types.bool;
@@ -14,7 +13,6 @@ in
Enables udev rules for keyboards from ZSA like the ErgoDox EZ, Planck EZ and Moonlander Mark I.
You need it when you want to flash a new configuration on the keyboard
or use their live training in the browser.
- Access to the keyboard is granted to users in the "plugdev" group.
You may want to install the wally-cli package.
'';
};
@@ -22,6 +20,5 @@ in
config = mkIf cfg.enable {
services.udev.packages = [ pkgs.zsa-udev-rules ];
- users.groups.plugdev = {};
};
}
diff --git a/pkgs/applications/science/math/polymake/default.nix b/pkgs/applications/science/math/polymake/default.nix
index 9566801479a3..f4f6366465b8 100644
--- a/pkgs/applications/science/math/polymake/default.nix
+++ b/pkgs/applications/science/math/polymake/default.nix
@@ -12,13 +12,13 @@
stdenv.mkDerivation rec {
pname = "polymake";
- version = "4.4";
+ version = "4.5";
src = fetchurl {
# "The minimal version is a packager friendly version which omits
# the bundled sources of cdd, lrs, libnormaliz, nauty and jReality."
url = "https://polymake.org/lib/exe/fetch.php/download/polymake-${version}-minimal.tar.bz2";
- sha256 = "sha256-2nF5F2xznI77pl2TslrxA8HLpw4fmzVnPOM8N3kOwJE=";
+ sha256 = "sha256-6UPUuzHBEvrYUjQONZW8WRwgcGkqFtUBg6OxBFZteZY=";
};
buildInputs = [
diff --git a/pkgs/applications/version-management/gitlab/gitaly/default.nix b/pkgs/applications/version-management/gitlab/gitaly/default.nix
index 8db31b58b21e..b4eceb190446 100644
--- a/pkgs/applications/version-management/gitlab/gitaly/default.nix
+++ b/pkgs/applications/version-management/gitlab/gitaly/default.nix
@@ -72,7 +72,7 @@ buildGoModule {
meta = with lib; {
homepage = "https://gitlab.com/gitlab-org/gitaly";
description = "A Git RPC service for handling all the git calls made by GitLab";
- platforms = platforms.linux;
+ platforms = platforms.linux ++ [ "x86_64-darwin" ];
maintainers = with maintainers; [ roblabla globin fpletz talyz ];
license = licenses.mit;
};
diff --git a/pkgs/build-support/setup-hooks/make-binary-wrapper.sh b/pkgs/build-support/setup-hooks/make-binary-wrapper.sh
new file mode 100644
index 000000000000..abc929cb89db
--- /dev/null
+++ b/pkgs/build-support/setup-hooks/make-binary-wrapper.sh
@@ -0,0 +1,384 @@
+
+set -euo pipefail
+
+# Assert that FILE exists and is executable
+#
+# assertExecutable FILE
+assertExecutable() {
+ local file="$1"
+ [[ -f "$file" && -x "$file" ]] || \
+ die "Cannot wrap '$file' because it is not an executable file"
+}
+
+# Generate a binary executable wrapper for wrapping an executable.
+# The binary is compiled from generated C-code using gcc.
+# makeWrapper EXECUTABLE OUT_PATH ARGS
+
+# ARGS:
+# --argv0 NAME : set name of executed process to NAME
+# (otherwise it’s called …-wrapped)
+# --inherit-argv0 : the executable inherits argv0 from the wrapper.
+# (use instead of --argv0 '$0')
+# --set VAR VAL : add VAR with value VAL to the executable’s
+# environment
+# --set-default VAR VAL : like --set, but only adds VAR if not already set in
+# the environment
+# --unset VAR : remove VAR from the environment
+# --chdir DIR : change working directory (use instead of --run "cd DIR")
+# --add-flags FLAGS : add FLAGS to invocation of executable
+
+# --prefix ENV SEP VAL : suffix/prefix ENV with VAL, separated by SEP
+# --suffix
+
+# To troubleshoot a binary wrapper after you compiled it,
+# use the `strings` command or open the binary file in a text editor.
+makeWrapper() {
+ assertExecutable "$1"
+ makeDocumentedCWrapper "$1" "${@:3}" | \
+ @CC@ \
+ -Wall -Werror -Wpedantic \
+ -Os \
+ -x c \
+ -o "$2" -
+}
+
+# Syntax: wrapProgram <PROGRAM> <MAKE-WRAPPER FLAGS...>
+wrapProgram() {
+ local prog="$1"
+ local hidden
+
+ assertExecutable "$prog"
+
+ hidden="$(dirname "$prog")/.$(basename "$prog")"-wrapped
+ while [ -e "$hidden" ]; do
+ hidden="${hidden}_"
+ done
+ mv "$prog" "$hidden"
+ # Silence warning about unexpanded $0:
+ # shellcheck disable=SC2016
+ makeWrapper "$hidden" "$prog" --inherit-argv0 "${@:2}"
+}
+
+# Generate source code for the wrapper in such a way that the wrapper inputs
+# will still be readable even after compilation
+# makeDocumentedCWrapper EXECUTABLE ARGS
+# ARGS: same as makeWrapper
+makeDocumentedCWrapper() {
+ local src docs
+ src=$(makeCWrapper "$@")
+ docs=$(docstring "$@")
+ printf '%s\n\n' "$src"
+ printf '%s\n' "$docs"
+}
+
+# makeCWrapper EXECUTABLE ARGS
+# ARGS: same as makeWrapper
+makeCWrapper() {
+ local argv0 inherit_argv0 n params cmd main flagsBefore flags executable length
+ local uses_prefix uses_suffix uses_assert uses_assert_success uses_stdio uses_asprintf
+ executable=$(escapeStringLiteral "$1")
+ params=("$@")
+ length=${#params[*]}
+ for ((n = 1; n < length; n += 1)); do
+ p="${params[n]}"
+ case $p in
+ --set)
+ cmd=$(setEnv "${params[n + 1]}" "${params[n + 2]}")
+ main="$main$cmd"$'\n'
+ n=$((n + 2))
+ [ $n -ge "$length" ] && main="$main#error makeCWrapper: $p takes 2 arguments"$'\n'
+ ;;
+ --set-default)
+ cmd=$(setDefaultEnv "${params[n + 1]}" "${params[n + 2]}")
+ main="$main$cmd"$'\n'
+ uses_stdio=1
+ uses_assert_success=1
+ n=$((n + 2))
+ [ $n -ge "$length" ] && main="$main#error makeCWrapper: $p takes 2 arguments"$'\n'
+ ;;
+ --unset)
+ cmd=$(unsetEnv "${params[n + 1]}")
+ main="$main$cmd"$'\n'
+ uses_stdio=1
+ uses_assert_success=1
+ n=$((n + 1))
+ [ $n -ge "$length" ] && main="$main#error makeCWrapper: $p takes 1 argument"$'\n'
+ ;;
+ --prefix)
+ cmd=$(setEnvPrefix "${params[n + 1]}" "${params[n + 2]}" "${params[n + 3]}")
+ main="$main$cmd"$'\n'
+ uses_prefix=1
+ uses_asprintf=1
+ uses_stdio=1
+ uses_assert_success=1
+ uses_assert=1
+ n=$((n + 3))
+ [ $n -ge "$length" ] && main="$main#error makeCWrapper: $p takes 3 arguments"$'\n'
+ ;;
+ --suffix)
+ cmd=$(setEnvSuffix "${params[n + 1]}" "${params[n + 2]}" "${params[n + 3]}")
+ main="$main$cmd"$'\n'
+ uses_suffix=1
+ uses_asprintf=1
+ uses_stdio=1
+ uses_assert_success=1
+ uses_assert=1
+ n=$((n + 3))
+ [ $n -ge "$length" ] && main="$main#error makeCWrapper: $p takes 3 arguments"$'\n'
+ ;;
+ --chdir)
+ cmd=$(changeDir "${params[n + 1]}")
+ main="$main$cmd"$'\n'
+ uses_stdio=1
+ uses_assert_success=1
+ n=$((n + 1))
+ [ $n -ge "$length" ] && main="$main#error makeCWrapper: $p takes 1 argument"$'\n'
+ ;;
+ --add-flags)
+ flags="${params[n + 1]}"
+ flagsBefore="$flagsBefore $flags"
+ uses_assert=1
+ n=$((n + 1))
+ [ $n -ge "$length" ] && main="$main#error makeCWrapper: $p takes 1 argument"$'\n'
+ ;;
+ --argv0)
+ argv0=$(escapeStringLiteral "${params[n + 1]}")
+ inherit_argv0=
+ n=$((n + 1))
+ [ $n -ge "$length" ] && main="$main#error makeCWrapper: $p takes 1 argument"$'\n'
+ ;;
+ --inherit-argv0)
+ # Whichever comes last of --argv0 and --inherit-argv0 wins
+ inherit_argv0=1
+ ;;
+ *) # Using an error macro, we will make sure the compiler gives an understandable error message
+ main="$main#error makeCWrapper: Unknown argument ${p}"$'\n'
+ ;;
+ esac
+ done
+ # shellcheck disable=SC2086
+ [ -z "$flagsBefore" ] || main="$main"${main:+$'\n'}$(addFlags $flagsBefore)$'\n'$'\n'
+ [ -z "$inherit_argv0" ] && main="${main}argv[0] = \"${argv0:-${executable}}\";"$'\n'
+ main="${main}return execv(\"${executable}\", argv);"$'\n'
+
+ [ -z "$uses_asprintf" ] || printf '%s\n' "#define _GNU_SOURCE /* See feature_test_macros(7) */"
+ printf '%s\n' "#include <unistd.h>"
+ printf '%s\n' "#include <stdlib.h>"
+ [ -z "$uses_assert" ] || printf '%s\n' "#include <assert.h>"
+ [ -z "$uses_stdio" ] || printf '%s\n' "#include <stdio.h>"
+ [ -z "$uses_assert_success" ] || printf '\n%s\n' "#define assert_success(e) do { if ((e) < 0) { perror(#e); abort(); } } while (0)"
+ [ -z "$uses_prefix" ] || printf '\n%s\n' "$(setEnvPrefixFn)"
+ [ -z "$uses_suffix" ] || printf '\n%s\n' "$(setEnvSuffixFn)"
+ printf '\n%s' "int main(int argc, char **argv) {"
+ printf '\n%s' "$(indent4 "$main")"
+ printf '\n%s\n' "}"
+}
+
+addFlags() {
+ local result n flag flags var
+ var="argv_tmp"
+ flags=("$@")
+ for ((n = 0; n < ${#flags[*]}; n += 1)); do
+ flag=$(escapeStringLiteral "${flags[$n]}")
+ result="$result${var}[$((n+1))] = \"$flag\";"$'\n'
+ done
+ printf '%s\n' "char **$var = calloc($((n+1)) + argc, sizeof(*$var));"
+ printf '%s\n' "assert($var != NULL);"
+ printf '%s\n' "${var}[0] = argv[0];"
+ printf '%s' "$result"
+ printf '%s\n' "for (int i = 1; i < argc; ++i) {"
+ printf '%s\n' " ${var}[$n + i] = argv[i];"
+ printf '%s\n' "}"
+ printf '%s\n' "${var}[$n + argc] = NULL;"
+ printf '%s\n' "argv = $var;"
+}
+
+# chdir DIR
+changeDir() {
+ local dir
+ dir=$(escapeStringLiteral "$1")
+ printf '%s' "assert_success(chdir(\"$dir\"));"
+}
+
+# prefix ENV SEP VAL
+setEnvPrefix() {
+ local env sep val
+ env=$(escapeStringLiteral "$1")
+ sep=$(escapeStringLiteral "$2")
+ val=$(escapeStringLiteral "$3")
+ printf '%s' "set_env_prefix(\"$env\", \"$sep\", \"$val\");"
+ assertValidEnvName "$1"
+}
+
+# suffix ENV SEP VAL
+setEnvSuffix() {
+ local env sep val
+ env=$(escapeStringLiteral "$1")
+ sep=$(escapeStringLiteral "$2")
+ val=$(escapeStringLiteral "$3")
+ printf '%s' "set_env_suffix(\"$env\", \"$sep\", \"$val\");"
+ assertValidEnvName "$1"
+}
+
+# setEnv KEY VALUE
+setEnv() {
+ local key value
+ key=$(escapeStringLiteral "$1")
+ value=$(escapeStringLiteral "$2")
+ printf '%s' "putenv(\"$key=$value\");"
+ assertValidEnvName "$1"
+}
+
+# setDefaultEnv KEY VALUE
+setDefaultEnv() {
+ local key value
+ key=$(escapeStringLiteral "$1")
+ value=$(escapeStringLiteral "$2")
+ printf '%s' "assert_success(setenv(\"$key\", \"$value\", 0));"
+ assertValidEnvName "$1"
+}
+
+# unsetEnv KEY
+unsetEnv() {
+ local key
+ key=$(escapeStringLiteral "$1")
+ printf '%s' "assert_success(unsetenv(\"$key\"));"
+ assertValidEnvName "$1"
+}
+
+# Makes it safe to insert STRING within quotes in a C String Literal.
+# escapeStringLiteral STRING
+escapeStringLiteral() {
+ local result
+ result=${1//$'\\'/$'\\\\'}
+ result=${result//\"/'\"'}
+ result=${result//$'\n'/"\n"}
+ result=${result//$'\r'/"\r"}
+ printf '%s' "$result"
+}
+
+# Indents every non-empty line by 4 spaces. To avoid trailing whitespace, we don't indent empty lines
+# indent4 TEXT_BLOCK
+indent4() {
+ printf '%s' "$1" | awk '{ if ($0 != "") { print " "$0 } else { print $0 }}'
+}
+
+assertValidEnvName() {
+ case "$1" in
+ *=*) printf '\n%s\n' "#error Illegal environment variable name \`$1\` (cannot contain \`=\`)";;
+ "") printf '\n%s\n' "#error Environment variable name can't be empty.";;
+ esac
+}
+
+setEnvPrefixFn() {
+ printf '%s' "\
+void set_env_prefix(char *env, char *sep, char *prefix) {
+ char *existing = getenv(env);
+ if (existing) {
+ char *val;
+ assert_success(asprintf(&val, \"%s%s%s\", prefix, sep, existing));
+ assert_success(setenv(env, val, 1));
+ free(val);
+ } else {
+ assert_success(setenv(env, prefix, 1));
+ }
+}
+"
+}
+
+setEnvSuffixFn() {
+ printf '%s' "\
+void set_env_suffix(char *env, char *sep, char *suffix) {
+ char *existing = getenv(env);
+ if (existing) {
+ char *val;
+ assert_success(asprintf(&val, \"%s%s%s\", existing, sep, suffix));
+ assert_success(setenv(env, val, 1));
+ free(val);
+ } else {
+ assert_success(setenv(env, suffix, 1));
+ }
+}
+"
+}
+
+# Embed a C string which shows up as readable text in the compiled binary wrapper
+# documentationString ARGS
+docstring() {
+ printf '%s' "const char * DOCSTRING = \"$(escapeStringLiteral "
+
+
+# ------------------------------------------------------------------------------------
+# The C-code for this binary wrapper has been generated using the following command:
+
+
+makeCWrapper $(formatArgs "$@")
+
+
+# (Use \`nix-shell -p makeBinaryWrapper\` to get access to makeCWrapper in your shell)
+# ------------------------------------------------------------------------------------
+
+
+")\";"
+}
+
+# formatArgs EXECUTABLE ARGS
+formatArgs() {
+ printf '%s' "$1"
+ shift
+ while [ $# -gt 0 ]; do
+ case "$1" in
+ --set)
+ formatArgsLine 2 "$@"
+ shift 2
+ ;;
+ --set-default)
+ formatArgsLine 2 "$@"
+ shift 2
+ ;;
+ --unset)
+